//带标题的控件
var React = require("react");
var WidgetFactory = require("../widget/widgetFactory");
var Label = require("../widget/label");
var Title = require("./title");

module.exports = React.createClass({

    hasTitle: false,

    titleLabel: null,

    widget: null,

    titleHeight: 0,

    widgetHeight: 0,

    contentWidgetName: null,

    className: "h5-title-widget",

    render: function() {
        this.init();
        return (
            <div className={this.className}>
                {this.hasTitle ? <Title ref="title" titleLabel={this.titleLabel} /> : null}
                <div className="h5-title-widget-container">
                    {this.widget}
                </div>
            </div>
        );
        // todo:style={{height: this.widgetHeight}}?啥意思
    },

    init: function() {
        var self = this;
        var options = this.props.options;
        $.map(options.items, function(item, index) {
            if(item.type == "label" && item.widgetName.indexOf("TITLE_") === 0) {
                item.width = options.width;
                self.titleLabel = <Label options={item}/>;
            }
        });
        $.map(options.items, function(item, index) {
            if(item.type != "label" || item.widgetName.indexOf("TITLE_") < 0) {
                self.contentWidgetName = item.widgetName;
                self.hasTitle = (self.titleLabel != null || item.showToolbar === true);
                self.titleHeight = self.hasTitle ? 40 : 0;
                self.widgetHeight = options.height - self.titleHeight;
                //todo 和图表解耦合
                if(item.type == "chartwidget") {
                    self.className += " h5-title-widget-chart";
                }
                item.isAutoLayout = options.isAutoLayout;
                item.sessionID = options.sessionID;
                item.width = options.width;
                item.height = self.widgetHeight;
                item.hasFormBackground = options.hasFormBackground;
                item.appendTool = self.appendTool;
                item.fireWidgetLink = options.fireWidgetLink;
                item.onDoHyperLink = options.onDoHyperLink;
                item.initLink = options.initLink;
                self.widget = WidgetFactory.createWidget(item);
            }
        });
    },

    appendTool: function(tool) {
        this.refs["title"].setState({
            tool: tool
        });
    },

    refreshWhenBeLinked: function(parameters) {
        this.refs[this.contentWidgetName].refreshWhenBeLinked(parameters);
    },

    reset: function() {

    }
});