var React =require("react");
var ReactDOM = require("react-dom");

module.exports = {

    attr: {},

    componentDidMount: function () {
        this.afterWidgetInit();
    },

    handleChange: function(event) {
        this.attr.value = event.target.value;
        this.setValue(event.target.value);
        if(!this.isValidate()) {
            $(this.getElement()).addClass("h5-widget-invalidate");
        } else {
            $(this.getElement()).removeClass("h5-widget-invalidate");
        }
        this.fireWidgetValueChange();
        this.fireEvent("afteredit", event);
    },

    getValue: function() {
        return this.getElement().value;
    },

    setValue: function(value) {
        this.setState({
            value: value
        });
    },

    reset: function() {
        ReactDOM.findDOMNode(this).value = "";
        this.setState({
            value: ""
        });
    },

    getElement: function() {
        return ReactDOM.findDOMNode(this);
    }
};