/**
 * Created by Wei on 15/12/28.
 */

var React = require("react");
var ReactDOM = require("react-dom");
var Widget = require("../widget");
var TextBase = require("./textbase");

module.exports = React.createClass({

    mixins : [Widget, TextBase],

    render: function() {
        var options = this.props.options;
        this.attr = this.getAttrFromOptions(options);
        this.attr.value = (this.state && this.state.value !== undefined) ? this.state.value : options.value;
        return <input className="h5-text-editor" {...this.attr} onChange={this.handleChange}></input>
    },

    isValidate: function() {
        if(!this.validateBlank()) {
            this.errorMsg = "值不允许为空";
            return false;
        }
        if(this.props.options.regex) {
            this.errorMsg = "输入值不符合规范";
            return this.getValue().match(this.props.options.regex);
        }
        return true;
    }
});