var React = require("react");
var ReactDOM = require("react-dom");
var BaseUtils = require("../../../utils/baseUtils");

module.exports = React.createClass({

    componentDidMount: function() {
        var self = this;
        BaseUtils.createClickEvent($(ReactDOM.findDOMNode(this)), function(e) {
            BaseUtils.stopEvent(e);
            if($.isFunction(self.props.onClick)) {
                self.props.onClick(e);
            }
        });
        BaseUtils.createMoveInAndOutEvent($(ReactDOM.findDOMNode(this)), function(e) {
            if($.isFunction(self.props.onTouchStart)) {
                self.props.onTouchStart(e);
            }
        }, function(e) {
            if($.isFunction(self.props.onTouchEnd)) {
                self.props.onTouchEnd(e);
            }
        });
    },

    render: function() {
        var text = this.props.text;
        if(this.props.type === "combo") {
            return <a className={this.props.isSelected ? "selected" : ""} options={text} title={text}>{text}</a>;
        } else if(this.props.type === "check") {
            return <a className={this.props.isSelected ? "selected" : ""}>
                       <i className="h5_icon-blank"></i>
                       <span>{text}</span>
                   </a>;
        }
        return <div />;
    }

});