/**
 * Created by Wei on 15/12/28.
 */

var React = require("react");
var ReactDOM = require("react-dom");
var Widget = require("./widget");
var BaseUtils = require("../../utils/baseUtils");

module.exports = React.createClass({

    mixins : [Widget],

    componentDidMount: function () {
        BaseUtils.createClickEvent($(ReactDOM.findDOMNode(this)), this.onClick);
        this.afterWidgetInit();
    },

    render: function(){
        this.attr = this.getAttrFromOptions(this.props.options);
        return (<div><input type="button" className="h5-button" {...this.attr} value={this.props.options.text}></input></div>);
    },

    onClick: function(e) {
        this.fireEvent("click", e);
    }
});