/**
 * Created by kyon on 16-1-22.
 */

var React = require('react');
var ReactDOM = require('react-dom');
var BaseUtils = require("../../../utils/baseUtils");

module.exports = {
    isLoading: false,
    needRestoreDefaultValue: true,
    data: [],

    getIndexInData: function (text, valueOnly) {
        var itemsData = this.getItemsData();
        for (var index = 0; index < itemsData.length; index++) {
            var itemData = itemsData[index];
            if (valueOnly) {
                if (text == itemData.value) {
                    return index;
                }
            } else {
                if (text == itemData.text || text == itemData.value) {
                    return index;
                }
            }
        }
        return -1;
    },

    isValidate: function() {
        if(!this.validateBlank()) {
            this.errorMsg = BaseUtils.unicode2CJK("z503cz4e0dz5141z8bb8z4e3az7a7a");
            return false;
        }
        return true;
    },

    getItemsData: function() {
        if(this.props.options.controlAttr && this.props.options.controlAttr.data) {
            return this.props.options.controlAttr.data;
        }
        return [];
    }

};