var React = require("react");
var ReactDOM = require("react-dom");
var BaseUtils = require("../../../utils/baseUtils");

module.exports = React.createClass({

    componentDidMount: function() {
        BaseUtils.createClickEvent($(ReactDOM.findDOMNode(this.refs.mainItem)), this.props.onClick);
    },

    render: function() {
        var wrapClassName, spanClassName;
        if(this.props.type === "radio") {
            wrapClassName = "h5-radio-group-item";
            spanClassName = "h5-radio-group-item-label";
        } else if(this.props.type === "check") {
            wrapClassName = "h5-check-group-item";
            spanClassName = "h5-check-group-item-label";
        }
        return (<li className={wrapClassName}>
                    <div ref="mainItem" className={this.props.isSelected ? "selected" : ""}>
                        <i className="h5_icon-blank" key="i"/>
                        <span className={spanClassName} key="span">{this.props.text}</span>
                    </div>
                </li>);
    }
});