/**
 * Created by Wei on 15/12/28.
 */

var React = require('react');
var Widget = require("../widget");
var TextBase = require('./textbase');
var BaseUtils = require("../../../utils/baseUtils");

module.exports = React.createClass({

    mixins : [Widget, TextBase],

    componentDidMount: function () {
        this.afterWidgetInit();
    },

    render: function() {
        var options = this.props.options;
        this.attr = this.getAttrFromOptions(options);
        this.attr.value = (this.state && this.state.value !== undefined) ? this.state.value : options.value;
        return <textarea className="h5-textarea" onChange={this.handleChange} {...this.attr}></textarea>;
    },

    isValidate: function() {
        if(!this.validateBlank()) {
            this.errorMsg = BaseUtils.unicode2CJK("z503cz4e0dz5141z8bb8z4e3az7a7a");
            return false;
        }
        if(this.props.options.regex) {
            this.errorMsg = BaseUtils.unicode2CJK("z8f93z5165z503cz4e0dz7b26z5408z89c4z8303");
            return this.getValue().match(this.props.options.regex);
        }
        return true;
    }
});