/**
 * Created by kyon on 16-1-26.
 */
var React = require("react");
var PropTypes = React.PropTypes;


module.exports = React.createClass({

    getInitialState: function(){
        return{
            isHide:false
        }
    },

    propTypes: {
        onHide: PropTypes.func,
        content: PropTypes.string
    },

    getDefaultProps: function(){
      return{
          isPart:false
      }
    },

    render: function() {
        var content = this.props.content || '';
        var outClassName;
        var spinClassName;
        var contentClassName;
        if (this.props.isPart) {
            outClassName = "h5-loading-part";
            spinClassName = "h5-loading-spin-part";
            contentClassName = "h5-loading-content-part";
        } else {
            outClassName = "h5-dialog";
            spinClassName = "h5-dialog-spin";
            contentClassName = "h5-dialog-content";
        }
        if (this.state.isHide) {
            outClassName += "-hide";
        }
        return <div className={outClassName}>
            <i className={spinClassName}></i>
            <div className={contentClassName}>{content}</div>
        </div>
    },

    hide: function(){
        this.setState({
            isHide:true
        });

        if(typeof this.props.onHide == "function"){
            this.props.onHide();
        }
    },

    show: function() {
        this.setState({
            isHide: false
        });
    }

});