var WidgetFactory = require('./widgetFactory');
var React = require("react");

module.exports = React.createClass({

    scaleWidget: null,

    render: function () {
        var options = this.props.options;
        var scaleOpotions = options.items[0];
        scaleOpotions.fireWidgetValueChange = options.fireWidgetValueChange;
        scaleOpotions.initLink = options.initLink;
        scaleOpotions.sessionID = options.sessionID;
        this.scaleWidget = options.items ? WidgetFactory.createWidget(scaleOpotions) : null;
        return this.scaleWidget;
    },

    reset: function(){
        var widgetName = this.props.options.widgetName;
        if (this.scaleWidget !== null) {
            this.refs[widgetName].reset();
        }
    },

    pushLinkWidget: function(widget) {
        this.refs[this.props.options.widgetName].pushLinkWidget(widget);//该控件会影响到的控件
    },

    pushLinkedWidget: function(widget) {
        this.refs[this.props.options.widgetName].pushLinkedWidget(widget);//该控件被这些控件影响
    },

    getValue: function () {
        var widgetName = this.props.options.widgetName;
        if (this.scaleWidget !== null) {
            return this.refs[widgetName].getValue();
        }
    },

    setValue: function (value) {
        var widgetName = this.props.options.widgetName;
        if (this.scaleWidget !== null) {
            this.refs[widgetName].setValue(value);
        }
    },

    getWidgetName: function() {
       return this.props.options.widgetName;
    },

    isValidate: function() {
        return this.refs[this.props.options.widgetName].isValidate();
    },

    getErrorMessage: function() {
        return this.refs[this.props.options.widgetName].getErrorMessage();
    }
});