/**
 * Created by Wei on 16/1/18.
 */

var React = require('react');
var ReactDOM = require('react-dom');

module.exports = React.createClass({
    numberOfRecordsShownOnce: 500,

    getInitialState: function() {
        return {
            shownIndex: 0
        }
    },

    render: function() {
        var index = 0;
        var items = [];
        for(; index < this.state.shownIndex + this.numberOfRecordsShownOnce; index ++) {
            if(this.props.data.length > index) {
                var text = this.props.data[index]["text"];
                var item = this.props.createItem(index, text);
                items.push(item);
            } else {
                this.state.shownIndex = index - 1;
                break;
            }
        }
        var className = "h5-combolist";
        if(items.length == 0) {
            className += " h5-combolist-no-data";
        }
        return <div style={{display:"none"}} ref="comboList" className={className} onScroll={this.listDidScroll}>{items}</div>;
    },

    getListDOM: function() {
        return ReactDOM.findDOMNode(this.refs.comboList);
    },

    listDidScroll: function() {
        if(!this.props.noNeedScrollLoad) {
            var list = this.getListDOM();
            var scrollHeight = list.scrollHeight;
            var scrollTop = list.scrollTop;
            var listHeight = $(list).height();
            if(listHeight + scrollTop >= scrollHeight) {
                if(this.state.shownIndex < this.props.data.length - 1) {
                    //load next 200
                    this.setState({
                        shownIndex: this.state.shownIndex + this.numberOfRecordsShownOnce
                    });
                } else {
                    this.props.checkLoad();
                }
            }
        }
    }
});